# Generated by Django 5.0.9 on 2024-09-24 18:19

import django.db.models.deletion
import taggit.managers
import utilities.json
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ('extras', '0121_customfield_related_object_filter'),
        ('ipam', '0070_vlangroup_vlan_id_ranges'),
        ('netbox_netauto_plugin', '0001_initial'),
    ]

    operations = [
        migrations.AlterField(
            model_name='flexapplication',
            name='dst_address',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to='ipam.ipaddress'),
        ),
        migrations.CreateModel(
            name='L4Application',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('name', models.CharField(max_length=30, unique=True)),
                ('description', models.TextField(blank=True, null=True)),
                ('dst_port', models.PositiveIntegerField()),
                ('tcp_wan', models.CharField(max_length=50)),
                ('tcp_lan', models.CharField(max_length=50)),
                ('persistence_profile', models.CharField(blank=True, max_length=50)),
                ('health_monitor_profile', models.CharField(blank=True, max_length=50)),
                ('dst_address', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to='ipam.ipaddress')),
                ('health_monitor', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='L4_apps', to='netbox_netauto_plugin.healthmonitor')),
                ('tags', taggit.managers.TaggableManager(through='extras.TaggedItem', to='extras.Tag')),
            ],
            options={
                'ordering': ('name',),
            },
        ),
        migrations.CreateModel(
            name='mTLSApplication',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False)),
                ('created', models.DateTimeField(auto_now_add=True, null=True)),
                ('last_updated', models.DateTimeField(auto_now=True, null=True)),
                ('custom_field_data', models.JSONField(blank=True, default=dict, encoder=utilities.json.CustomFieldJSONEncoder)),
                ('name', models.CharField(max_length=30, unique=True)),
                ('description', models.TextField(blank=True, null=True)),
                ('dst_port', models.PositiveIntegerField()),
                ('tcp_wan', models.CharField(max_length=50)),
                ('tcp_lan', models.CharField(max_length=50)),
                ('persistence_profile', models.CharField(blank=True, max_length=50)),
                ('health_monitor_profile', models.CharField(blank=True, max_length=50)),
                ('http', models.CharField(max_length=50)),
                ('client_ssl_profile', models.CharField(max_length=50)),
                ('server_ssl_profile', models.CharField(max_length=50)),
                ('oneconnect_profile', models.CharField(max_length=50)),
                ('dst_address', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to='ipam.ipaddress')),
                ('health_monitor', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='mtls_apps', to='netbox_netauto_plugin.healthmonitor')),
                ('tags', taggit.managers.TaggableManager(through='extras.TaggedItem', to='extras.Tag')),
            ],
            options={
                'ordering': ('name',),
            },
        ),
    ]
